--- old/usr/src/uts/i86pc/os/cpuid.c	2014-04-23 20:47:21.169520913 -0400
+++ new/usr/src/uts/i86pc/os/cpuid.c	2014-04-23 20:47:21.175531636 -0400
@@ -22,6 +22,7 @@
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011 by Delphix. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc. All rights reserved.
+ * Copyright 2014 Josef "Jeff" Sipek <jeffpc@josefsipek.net>
  */
 /*
  * Copyright (c) 2010, Intel Corporation.
@@ -163,7 +164,8 @@
 	"svm",
 	"topoext",
 	"f16c",
-	"rdrand"
+	"rdrand",
+	"x2apic",
 };
 
 boolean_t
@@ -1311,6 +1313,9 @@
 			}
 		}
 	}
+	if (cp->cp_ecx & CPUID_INTC_ECX_X2APIC) {
+		add_x86_feature(featureset, X86FSET_X2APIC);
+	}
 	if (cp->cp_edx & CPUID_INTC_EDX_DE) {
 		add_x86_feature(featureset, X86FSET_DE);
 	}
--- old/usr/src/uts/intel/sys/x86_archext.h	2014-04-23 20:47:21.524383422 -0400
+++ new/usr/src/uts/intel/sys/x86_archext.h	2014-04-23 20:47:21.530125266 -0400
@@ -116,6 +116,7 @@
 #define	CPUID_INTC_ECX_DCA	0x00040000	/* direct cache access */
 #define	CPUID_INTC_ECX_SSE4_1	0x00080000	/* SSE4.1 insns */
 #define	CPUID_INTC_ECX_SSE4_2	0x00100000	/* SSE4.2 insns */
+#define	CPUID_INTC_ECX_X2APIC	0x00200000	/* x2APIC */
 #define	CPUID_INTC_ECX_MOVBE	0x00400000	/* MOVBE insn */
 #define	CPUID_INTC_ECX_POPCNT	0x00800000	/* POPCNT insn */
 #define	CPUID_INTC_ECX_AES	0x02000000	/* AES insns */
@@ -130,7 +131,7 @@
 	"\20"							\
 	"\37rdrand\36f16c\35avx\34osxsav\33xsave"		\
 	"\32aes"						\
-	"\30popcnt\27movbe\25sse4.2\24sse4.1\23dca"		\
+	"\30popcnt\27movbe\26x2apic\25sse4.2\24sse4.1\23dca"	\
 	"\20\17etprd\16cx16\13cid\12ssse3\11tm2"		\
 	"\10est\7smx\6vmx\5dscpl\4mon\2pclmulqdq\1sse3"
 
@@ -346,7 +347,7 @@
 #define	X86FSET_PGE		4
 #define	X86FSET_DE		5
 #define	X86FSET_CMOV		6
-#define	X86FSET_MMX 		7
+#define	X86FSET_MMX		7
 #define	X86FSET_MCA		8
 #define	X86FSET_PAE		9
 #define	X86FSET_CX8		10
@@ -379,6 +380,7 @@
 #define	X86FSET_TOPOEXT		37
 #define	X86FSET_F16C		38
 #define	X86FSET_RDRAND		39
+#define	X86FSET_X2APIC		40
 
 /*
  * flags to patch tsc_read routine.
@@ -639,7 +641,7 @@
 
 #if defined(_KERNEL) || defined(_KMEMUSER)
 
-#define	NUM_X86_FEATURES	40
+#define	NUM_X86_FEATURES	41
 extern uchar_t x86_featureset[];
 
 extern void free_x86_featureset(void *featureset);
